---
# Author: Guillaume Mella
# Description: install the oival service on server side
# this plsybooks requires following variables
# - release
# - xar_files or xar_files_beta if release='beta'

- name: 'Define variables if beta release '
  block:
  - name: "find all xar files"
    find:
      paths: "/data/jmmc-existdb-repo/public"
      patterns: "{{xar_patterns_beta}}"
    register: "tmpxar_files"
    
  - set_fact:
     oival_version: '-beta'
     xar_files: "{{ tmpxar_files }}"
# We can't define xar_files in find step else public branch erases the variable value. By chance set_fact is not called bellown
  
  when: release is defined and release  == 'beta'

  
- name: 'Define variables if public release '
  block:
  - name: "find all xar files"
    find:
      paths: "/data/jmmc-existdb-repo/public"
      patterns: "{{xar_patterns}}"
    register: "tmpxar_files"

  - set_fact:
     oival_version: ''
     xar_files: "{{ tmpxar_files }}"
  when: release is undefined or release != 'beta'

#- debug: "var=xar_files"
#- debug: "var=oival_version"

# define one entry per xar to build a docker volume list
- set_fact:
    volumes: ['/data/jmmc-existdb-repo/public/exist_5.1.0_conf_big_output_size.xml:/exist/conf.xml']
- set_fact:
    volumes: "{{ volumes }} + ['{{ item.path }}:/exist/autodeploy/{{ item.path |basename }}']"
  with_items: "{{ xar_files.files }}" 

#- debug: "var=volumes"

- fail:
    msg: "Missing XAR on datastore: {{volumes}} VS. {{xar_patterns}}"
  when: volumes|length != xar_files.files|length + 1

- name: 'make oival service running with docker-compose'
  docker_service:
    project_name: 'oival{{oival_version}}'
    definition:
      version: "2.0"
      services:
        existdb:
          image: 'existdb/existdb:5.1.0'
          ports: "{{services['jmmc-oival' + oival_version].ports}}"
          volumes: "{{ volumes }}"
          restart: 'unless-stopped'
  become: 'yes'
